Personal tools

Diagrams/Install

From HaskellWiki

< Diagrams(Difference between revisions)
Jump to: navigation, search
(Update install instructions for 0.6)
(Update Windows install directions)
 
(6 intermediate revisions by 3 users not shown)
Line 13: Line 13:
 
You will need to have the cairo C library (along with development headers) installed through your operating system's package manager or otherwise. After that, it should ''ideally'' be enough to run
 
You will need to have the cairo C library (along with development headers) installed through your operating system's package manager or otherwise. After that, it should ''ideally'' be enough to run
   
cabal install gtk2hs-buildtools -fcairo diagrams
+
cabal install gtk2hs-buildtools
  +
cabal install -fcairo diagrams
   
(If you ''don't'' want the SVG backend you can add the flag <code>-f-svg</code>.)
+
(If you ''don't'' want the SVG backend you can add the flag <code>-f-svg</code>.) If you have already installed <code>gtk2hs-buildtools</code> in the past then you probably don't need to reinstall it; though note that in order to build <code>cairo</code> under GHC 7.6 you need to have a recent enough version of <code>gtk2hs-buildtools</code>; otherwise you will get some error messages having to do with the FFI.
   
 
This will probably work under Linux/Unix but some workarounds may currently be required on Windows or Mac OS X; see below. Please edit this page to add information about any problems you encounter, workarounds you discover, etc.
 
This will probably work under Linux/Unix but some workarounds may currently be required on Windows or Mac OS X; see below. Please edit this page to add information about any problems you encounter, workarounds you discover, etc.
Line 21: Line 21:
 
== Installing on Windows ==
 
== Installing on Windows ==
   
[http://jystic.com/2010/10/20/installing-gtk2hs-on-windows/ Here are instructions] for installing gtk2hs on Windows. They work with the exception of the [http://hackage.haskell.org/trac/gtk2hs/ticket/1203 issue described here], which can be circumvented by passing the --global option to 'cabal install cairo' (if you don't mind installing cairo in the global package database).
+
[http://jystic.com/2010/10/20/installing-gtk2hs-on-windows/ Here are instructions] for installing gtk2hs on Windows. Note that Haskell's gtk package requires gtk+-2.x, not 3.x. gtk+-2.24 is the most recent in this series at the time of this writing, and works.
 
[http://www.haskell.org/pipermail/haskell-cafe/2011-May/091656.html Here is a discussion] about the most recent difficulties.
 
   
 
== Installing on Mac OS X ==
 
== Installing on Mac OS X ==
   
* make sure you have Xquartz (aka X windows intalled). GTK needs it.
+
* make sure you have Xquartz (aka X windows) installed. GTK needs it.
   
 
* make sure you're using a 64bit haskell install (you can check this by typing maxBound :: Int in ghci and seeing if you get 9223372036854775807).
 
* make sure you're using a 64bit haskell install (you can check this by typing maxBound :: Int in ghci and seeing if you get 9223372036854775807).
Line 36: Line 36:
   
 
* type gtk-demo to check gtk installed ok.
 
* type gtk-demo to check gtk installed ok.
  +
  +
* It may be necessary to set a path for pkg-config to find some install packages: <code>export PKG_CONFIG_PATH=/usr/X11/lib/pkgconfig</code>
   
 
* cabal install gtk2hs-buildtools
 
* cabal install gtk2hs-buildtools

Latest revision as of 15:06, 17 May 2014

Contents

[edit] 1 Default installation

The first step is to install the Haskell Platform, if you don't already have it. Then it should be enough to simply run

 cabal install diagrams

By default this will give you diagrams-core (core data structures), diagrams-lib (standard library), diagrams-contrib (user-contributed modules), and diagrams-svg (native Haskell backend outputting SVG files).

[edit] 2 Installing the cairo backend

As of the 0.6 release of diagrams, the SVG backend has replaced the cairo backend as the default "out of the box" backend. However, the cairo backend still has a few advantages (support for text alignment, embedded images, and animations, as well as the ability to output PNG, PDF, and PS files). However, installing the cairo backend can be more challenging, especially on OS X.

You will need to have the cairo C library (along with development headers) installed through your operating system's package manager or otherwise. After that, it should ideally be enough to run

 cabal install gtk2hs-buildtools
 cabal install -fcairo diagrams

(If you don't want the SVG backend you can add the flag -f-svg.) If you have already installed gtk2hs-buildtools in the past then you probably don't need to reinstall it; though note that in order to build cairo under GHC 7.6 you need to have a recent enough version of gtk2hs-buildtools; otherwise you will get some error messages having to do with the FFI.

This will probably work under Linux/Unix but some workarounds may currently be required on Windows or Mac OS X; see below. Please edit this page to add information about any problems you encounter, workarounds you discover, etc.

[edit] 2.1 Installing on Windows

Here are instructions for installing gtk2hs on Windows. Note that Haskell's gtk package requires gtk+-2.x, not 3.x. gtk+-2.24 is the most recent in this series at the time of this writing, and works.

[edit] 2.2 Installing on Mac OS X

  • make sure you have Xquartz (aka X windows) installed. GTK needs it.
  • make sure you're using a 64bit haskell install (you can check this by typing maxBound :: Int in ghci and seeing if you get 9223372036854775807).
  • make sure you're using homebrew, and uninstall gtk and **ALL** of its dependencies (you can do that yourself e.g. type brew list | xargs brew uninstall but note this will remove *all* homebrew packages).
  • type brew update
  • type brew install gtk
  • type gtk-demo to check gtk installed ok.
  • It may be necessary to set a path for pkg-config to find some install packages: export PKG_CONFIG_PATH=/usr/X11/lib/pkgconfig
  • cabal install gtk2hs-buildtools
  • cabal install gtk
  • If you want to try the example in the diagrams tutorial type cabal install diagrams-cairo.
  • Some users report problems with chart-gtk (which has nothing to do with diagrams) so ignore any other installation instructions which tell you to install it and run an example program called plott.

Old instructions (now superseded):

Here are instructions for getting gtk installed under OS X Lion with GHC 7.2. They should also work for 7.4.

Here is more discussion about installation under OS X Lion. See also this reddit thread.